/*
  Copyright 2010-2011 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <QtGui>

#include "DateDelegate.hpp"

QWidget * DateDelegate::createEditor (QWidget * parent, const QStyleOptionViewItem & option, const QModelIndex & index ) const
{
    QComboBox* combo = new QComboBox(parent);
    QDate date(_year, _month, _day);

    for(int i=0; i<date.daysInMonth(); i++)
    	combo->addItem(QString::number(i+1));

    return combo;
}

void DateDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
				  const QModelIndex &index) const
{
    QComboBox *combo = qobject_cast<QComboBox *>(editor);
    QString s ;
 
    s = s.sprintf("%02d/%02d/%04d", combo->currentIndex()+1, _month, _year);

    model->setData(index, qVariantFromValue(s));
}

void DateDelegate::setEditorData(QWidget *editor,
				 const QModelIndex &index) const
{
    QComboBox* combo = qobject_cast<QComboBox *>(editor);
    combo->setCurrentIndex(qVariantValue<QString>(index.data()).left(2).toInt()-1);
}
